using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace FileListRenamer
{
    public partial class MainForm : Form
    {
        int prevLine = -1;

        public MainForm()
        {
            InitializeComponent();
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            int line = richTextBox1.GetLineFromCharIndex(richTextBox1.SelectionStart);

            if (prevLine != line)
            {
                prevLine = line;
                if (line < listBox1.Items.Count)
                {
                    listBox1.SelectedIndexChanged -= listBox1_SelectedIndexChanged;
                    listBox1.SelectedIndex = line;
                    listBox1.SelectedIndexChanged += new EventHandler(listBox1_SelectedIndexChanged);
                }

                label1.Text = "Line " + (line+1) + " of " + richTextBox1.Lines.Length;
            }
        }

        private void goButton_Click(object sender, EventArgs e)
        {
            if (DialogResult.No == MessageBox.Show("Proceed?", "Renaming", MessageBoxButtons.YesNo, MessageBoxIcon.Question))
                return;

            goButton.Enabled = false;

            try
            {
                if (richTextBox1.Lines.Length != listBox1.Items.Count)
                    throw new Exception("Number of files is different to number of lines in text-box!");

                if (!Directory.Exists(folderTextBox.Text))
                    throw new Exception("Directoy '" + folderTextBox.Text + "' don't exist!");

                if (listBox1.Items.Count > 9999)
                    throw new Exception("Number of files more than 9999 is not supported");


                string pathPrefix = folderTextBox.Text + "\\";
                //check
                //todo

                //first pass
                for (int i = 0; i < listBox1.Items.Count; i++)
                {
                    File.Move(pathPrefix + listBox1.Items[i], pathPrefix + "FLR" + i.ToString("d4") + "_" + listBox1.Items[i]);
                }

                //second pass
                for (int i = 0; i < listBox1.Items.Count; i++)
                {
                    File.Move(pathPrefix + "FLR" + i.ToString("d4") + "_" + listBox1.Items[i], pathPrefix + richTextBox1.Lines[i]);
                }

            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }

            goButton.Enabled = true;
        }

        private void openFolderButton_Click(object sender, EventArgs e)
        {
            if (Directory.Exists(folderTextBox.Text))
            {
                listBox1.Items.Clear();
                richTextBox1.Text = "";
                string[] files = Directory.GetFiles(folderTextBox.Text);
                for (int i = 0; i < files.Length; i++)
                {
                    string fn = Path.GetFileName(files[i]);
                    string nl;
                    if (i != (files.Length - 1))
                        nl = "\r\n";
                    else
                        nl = "";

                    listBox1.Items.Add(fn);
                    richTextBox1.AppendText(fn + nl);
                }
                label2.Text = "Files: " + files.Length;
                richTextBox1.Select(0, 0);
                richTextBox1.ScrollToCaret();
            }
            else
            {
                listBox1.Items.Clear();
                richTextBox1.Text = "";
                MessageBox.Show("Directoy '" + folderTextBox.Text + "' don't exist!");
            }
            
        }

        private void button1_Click(object sender, EventArgs e)
        {
            folderBrowserDialog1.ShowDialog();

            if (folderBrowserDialog1.SelectedPath != "")
            {
                folderTextBox.Text = folderBrowserDialog1.SelectedPath;
                openFolderButton_Click(null, null);
            }
        }

        private void listBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            if(listBox1.SelectedIndex <= richTextBox1.Lines.Length)
            {
                int firstcharindex = richTextBox1.GetFirstCharIndexFromLine(listBox1.SelectedIndex);
                string currentlinetext = richTextBox1.Lines[listBox1.SelectedIndex];

                richTextBox1.Select(firstcharindex, currentlinetext.Length);
                richTextBox1.ScrollToCaret();
                richTextBox1.Focus();
            }
        }
    }
}